import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import pao.reports.*;
import java.sql.*;
import java.text.*;
import java.util.*;

public class PaoReportsSample extends HttpServlet {
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException{

        String type = request.getParameter("type");
		byte[] buf = null;		

        if(type.equals("Baisuu")){
        	buf = getBaisuu();
        }
        else if(type.equals("Zip")){
        	buf = getAddressList();
        }
        else if(type.equals("Mitsumori")){
        	buf = getMitsumori();
        }
        else{
        	buf = getBaisuu();
        }
        
        if (buf == null) throw new NullPointerException("k");
        
        // PDFt@C_E[h
        response.setContentType("application/octet-stream");
        response.setHeader("Content-disposition", "attachment; filename=\"sample.pdf\"");
        response.setContentLength(buf.length);
        response.setHeader("Expires", "0");
        response.setHeader("Cache-Control", "must-revalidate, post-check=0,pre-check=0");
        
        // uEUɕ\
        response.setContentType("application/pdf;charset=Windows-31J");
        response.setHeader("Content-disposition","inline;");
        response.setContentLength(buf.length);
        
        ServletOutputStream output = response.getOutputStream();
        
        output.write(buf);
        output.close();
                

    }
	//PO̔{Xg
	public byte[] getBaisuu()
	{
		byte[] ret = null;		

		//CX^X̐
		IReport paoRep = ReportCreater.getReport();

		try
		{
			//[`̂̓ǂݍ
			paoRep.loadDefFile("/usr/local/tomcat/webapps/axis/WEB-INF/classes/pao/Programers.xml");
	
			int page = 0; //Ő`
			int line = 0; //s`

			for (int i = 0; i < 60; i++)
			{
				if (i % 15 == 0) //115sŊJn
				{
					//ŊJn錾
					paoRep.pageStart();
					page++;		//ŐCNg
					line = 0;	//s

					//wb_̃Zbg
					//̃Zbg
			        GregorianCalendar cal = new GregorianCalendar();
					paoRep.write("DateTime", cal.getTime().toString());
					paoRep.write("Page", "Page - " + Integer.toString(page));

				}
				line++; //sCNg

				//ׂ̃Zbg
				//JԂ̃Zbg
				paoRep.write("LineNo", Integer.toString(i+1) , line);
				paoRep.write("10Baisu", Integer.toString((i+1)*10) , line);
				//JԂ}`()̃Zbg
				paoRep.write("HLine", line);

				if (((i+1) % 15) == 0) paoRep.pageEnd(); //115sŏI錾
			}
	
			ret = paoRep.savePdfData(); // PDFf[^ۑ
		}
		catch(Exception ex)
		{}

		return ret;

	}


	//X֔ԍEZXg擾
	public byte[] getAddressList()
	{
		byte[] ret = null;		

		String drv = "com.mysql.jdbc.Driver";
		String dsn = "jdbc:MySQL://localhost:3306/test";
		Connection cn = null;
		Statement st = null;
		ResultSet rs = null;
		
		// MySQL JDBC hCo[h
		try {
			Class.forName(drv);
		} catch (Exception e) {
			System.out.println("<P>JDBC hCo[hG[<BR>" + e.toString() + "</P>");
		}
		
		// MySQL JDBC ڑ
		try {
			cn = DriverManager.getConnection(dsn, "pao", "paopao");
		} catch (Exception e) {
			System.out.println("<P>JDBC ڑG[<BR>" + e.toString() + "</P>");
		}
		
		//CX^X̐
		IReport paoRep = ReportCreater.getReport();


        int page = 0;
        int line = 999;
        GregorianCalendar cal = new GregorianCalendar();
        String hDate = cal.getTime().toString();

		
		try {
	      // Xe[ggIuWFNg𐶐
			st = cn.createStatement();
			
			String sql = "SELECT * FROM PostTable";
	      // NG[sČʃZbg擾
	      rs = st.executeQuery(sql);

		  //[`̂̓ǂݍ
		  paoRep.loadDefFile("/usr/local/tomcat/webapps/axis/WEB-INF/classes/pao/AddrRep3.xml");

	      // ꂽs[v
	      while(rs.next()) {

	    	  line++;
              if (line > 32){ // Head Print
                  if ( page != 0 ) paoRep.pageEnd();
				
					page++;

					if(page == 6)
					{
						paoRep.loadDefFile("/usr/local/tomcat/webapps/axis/WEB-INF/classes/pao/AddrRep4.xml");
					}

					paoRep.pageStart();

				  //
                  paoRep.write("DateTime", hDate);
                  //y[W
                  paoRep.write("Page", "Page-" + Integer.toString(page));

                  line = 1;		

				}

              //Body Print
              //X֔ԍ
              paoRep.write("ZipCode", rs.getString("zip_code"),    line);
              //s撬
              paoRep.write("Area", rs.getString("area"),    line);
              //Z
              paoRep.write("Address",     rs.getString("address"),        line);
              //r
			  paoRep.write("HLine", line);


				if(page > 5 && line % 2 == 0)
					paoRep.write("Hatch", line/2);  //Ԋ|

          }
          paoRep.pageEnd();

			ret = paoRep.savePdfData(); // PDFf[^ۑ

		} catch (Exception e) {
			System.out.println("<P>SELECT[<BR>" + e.toString() + "</P>");
		}
		
		// MySQL JDBC Xe[ggN[Y
		try {
			st.close();
		} catch (Exception e) {}
		
		// MySQL JDBC ڑN[Y
		try {
			cn.close();
		} catch (Exception e) {}
		
		return ret;

	}

	//Ϗ
	public byte[] getMitsumori()
	{
		byte[] ret = null;		


		String drv = "com.mysql.jdbc.Driver";
		String dsn = "jdbc:MySQL://localhost:3306/test";
		Connection cn = null;
		Statement st = null;
		Statement st2 = null;
		ResultSet rs = null;
		ResultSet rs2 = null;
		
		// MySQL JDBC hCo[h
		try {
			Class.forName(drv);
		} catch (Exception e) {
			System.out.println("<P>JDBC hCo[hG[<BR>" + e.toString() + "</P>");
		}
		
		// MySQL JDBC ڑ
		try {
			cn = DriverManager.getConnection(dsn, "pao", "paopao");
		} catch (Exception e) {
			System.out.println("<P>JDBC ڑG[<BR>" + e.toString() + "</P>");
		}
		
		//CX^X̐
		IReport paoRep = ReportCreater.getReport();

		try {
	      // Xe[ggIuWFNg𐶐
			st = cn.createStatement();
			
			//f[^Zbgփe[uZbgBwb_Ɩׂ2e[u
			String sql = "select * from MitsumoriHeader ORDER BY m_no";			
            // NG[sČʃZbg擾
		    rs = st.executeQuery(sql);

		    // ꂽs[v
		    while(rs.next()) {

		    	//[`̂̓ǂݍ
			    //\̐
			    paoRep.loadDefFile("/usr/local/tomcat/webapps/axis/WEB-INF/classes/pao/MitsuRep3.xml");
	
				paoRep.pageStart();
				paoRep.write("ql", rs.getString("customer"));
				paoRep.write("SҖ", rs.getString("t_name"));
				paoRep.pageEnd();
	
				//Ϗ̐
			    paoRep.loadDefFile("/usr/local/tomcat/webapps/axis/WEB-INF/classes/pao/MitsuRep4.xml");
				paoRep.pageStart();
	
				paoRep.write("ϔԍ", rs.getString("m_no"));
				paoRep.write("ql", rs.getString("customer"));
				paoRep.write("SҖ", rs.getString("t_name"));
				paoRep.write("ϓ", rs.getString("m_date"));
				
		        NumberFormat formatter = NumberFormat.getIntegerInstance(Locale.JAPAN);
		        
				paoRep.write("wb_v", formatter.format(rs.getObject("ttl_mny")));
				paoRep.write("Ŋz", formatter.format(rs.getObject("tax_mny")));
				paoRep.write("tb^v", formatter.format(rs.getObject("ttl_mny")));

				//ׂ̔wi쐬
				for (int i = 0 ; i < 7 ; i++ )
				{
					paoRep.write("iԔ", i+1);
					paoRep.write("ʔ", i+1);
					paoRep.write("P", i+1);
					paoRep.write("z", i+1);
					paoRep.write("iԐ", i+1);
					paoRep.write("i", i+1);
					paoRep.write("ʐ", i+1);
					paoRep.write("P", i+1);
					paoRep.write("z", i+1);
				}

				//ׂ̍쐬
			    // Xe[ggIuWFNg𐶐
				st2 = cn.createStatement();
	            // NG[sČʃZbg擾
				sql = "select * from MitsumoriDetail WHERE m_no = '" + rs.getString("m_no") + "' ORDER BY line_no";
			    rs2 = st2.executeQuery(sql);

			    int i = 0;
			    while(rs2.next()) {
			    	i++;
					paoRep.write("i", rs2.getString("s_no"), i);
					paoRep.write("i", rs2.getString("s_name"), i);
					paoRep.write("", formatter.format(rs2.getObject("amount")), i);
					paoRep.write("P", formatter.format(rs2.getObject("unit_price")), i);
					paoRep.write("z", formatter.format(rs2.getObject("sum_mny")), i);
				}
				paoRep.pageEnd();			
			}

			ret = paoRep.savePdfData(); // PDFf[^ۑ

		} catch (Exception e) {
			System.out.println("<P>SELECT[<BR>" + e.toString() + "</P>");
		}
		
		// MySQL JDBC Xe[ggN[Y
		try {
			st.close();
			st2.close();
		} catch (Exception e) {}
		
		// MySQL JDBC ڑN[Y
		try {
			cn.close();
		} catch (Exception e) {}
		
		return ret;

	}
}
