
import java.awt.event.*;
import javax.swing.*;
import java.awt.*;
import java.io.*;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import javax.xml.namespace.QName;


//import ac.pao.www.axis.SamplePdf_jws.*;

public class OutputPdfClient extends JFrame {

	static JRadioButton optSimpleData = null;
	static JRadioButton optMultiple10  = null;
	static JRadioButton optAddressList = null;
	static JRadioButton optEstimate = null;

	public static void main(String[] args) {

		OutputPdfClient sample = new OutputPdfClient("Output Pdf Client Sample");
	
		/* Iǉ */
		sample.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});

		/* ۂɕ\ */
		sample.setVisible(true);
	}

	public OutputPdfClient(String title) {
		setTitle(title);
		setBounds(0, 0, 500, 100);

        JButton btn = new JButton("Output PDF");
		optSimpleData = new JRadioButton("Simple Print Data",true);
		optMultiple10 = new JRadioButton("Multiple Of 10");
		optAddressList = new JRadioButton("Address List");
		optEstimate = new JRadioButton("Estimate");

		ButtonGroup group = new ButtonGroup();
		group.add(optSimpleData);
		group.add(optMultiple10);
		group.add(optAddressList);
		group.add(optEstimate);

        JPanel p = new JPanel();
        getContentPane().add(p);
        p.add(optSimpleData);
        p.add(optMultiple10);
        p.add(optAddressList);
        p.add(optEstimate);
        p.add(btn);

		getContentPane().add(p, BorderLayout.CENTER);
        btn.addActionListener(new myListener());

		setBackground(Color.WHITE );

	}
	
	//{^NbN̏
	public class myListener implements ActionListener {
	    public void actionPerformed(ActionEvent e){
	        try {

//	        	SamplePdfService locator = new SamplePdfServiceLocator(); 
//		    	SamplePdf service = locator.getSamplePdf();
//		    	byte pdfB[] = service.getPrintData();

		        String endpoint = "http://www.pao.ac:8080/axis/SamplePdf.jws";

	        	Service  service = new Service();
	        	Call     call    = (Call) service.createCall();

		        call.setTargetEndpointAddress( new java.net.URL(endpoint) );

		        String methodName = "getPrintData";
				if (optSimpleData.isSelected())
				{
					methodName = "getPrintData";
				}else if (optMultiple10.isSelected())
				{
					methodName = "getBaisuu";
				}else if (optAddressList.isSelected())
				{
					methodName = "getAddressList";
				}else if (optEstimate.isSelected())
				{
					methodName = "getMitsumori";
				}
		        
		        call.setOperationName(new QName("http://www.pao.ac:8080/", methodName));

	        	byte[] pdfB = (byte[]) call.invoke( new Object[0] );
		    	
	            try {
	              DataOutputStream dos = 
	  				new DataOutputStream(new FileOutputStream("Sample.PDF"));
	  			  dos.write(pdfB);
	  			  dos.close();

	            } catch (Exception ex) {
	              ex.printStackTrace();
	            }
	         
	        	if (JOptionPane.showConfirmDialog(
	        			OutputPdfClient.this,"PDFt@CuSample.PDFvƂOŃJgfBNgɏo͂܂B\n WindowsIEṕ̕AIEPDF\܂̂Łu͂vNbNĂB\nȊÓ̕AuvNbNĂB", "PDFo͊mF",JOptionPane.YES_NO_OPTION)
	                    ==JOptionPane.NO_OPTION) {
	        		return;
	        	}
	            
	            File fileParentDirectory=new File(".").getAbsoluteFile().getParentFile();
	            Runtime.getRuntime().exec("C:\\Program Files\\Internet Explorer\\IEXPLORE.EXE file://" + fileParentDirectory.getAbsolutePath() +"/Sample.PDF");

	            
//	            if(!Program.launch("Sample.PDF"))
//	            {
//	            	JOptionPane.showMessageDialog(null, "̊łPDFt@Co͂ł܂B\nuSample.PDFv̓JgfBNgɂ͏o͂Ă܂B", "PDF\s", JOptionPane.INFORMATION_MESSAGE);
//	            }
	            
	        } catch (Exception ex) {
	            System.err.println("G[łB\n" + ex.toString());
	        }
	    	
	    	

	    }
	
	}	

}

